#include <iostream>
using namespace std;

#define MAX 10
int enfileirar(int fila[], int &ffila, int valor);
int desenfileirar(int fila[], int &ifila, int ffila, int &valor);
int main(void) {

    // Declarando uma fila
    int fila[MAX];
    int ifila = 0;
    int ffila = -1;
    int op, v;

    do {
        cout << "1. Enfileirar inteiro positivo" << endl;
        cout << "2. Desenfileirar todos" << endl;
        cout << "3. Sair" << endl;
        cout << "Opcao: ";
        cin >> op;

        switch(op) {
            case 1: // Enfileirar
                cout << "Digite um numero inteiro positivo: ";
                cin >> v;
                enfileirar(fila, ffila, v);
                break;
            case 2:
                while(desenfileirar(fila, ifila, ffila, v)==0) {
                    if (v%5==0) cout << v << endl;
                }
                break;
        }
    } while(op!=3);
}

// Retorna 0 em caso de sucesso e 1 em caso de fila cheia
int enfileirar(int fila[], int &ffila, int valor) {
    // Verificar se a fila est cheia
    if (ffila >= MAX-1) return 1;
    // Se no estiver
    // Incrementar a posio final
    ffila = ffila + 1;
    // Guardar o valor na posio final
    fila[ffila] = valor;
    // Indica sucesso
    return 0;
}

int desenfileirar(int fila[], int &ifila, int ffila, int &valor) {
    // Verificar se a fila t vazia (e retornar erro se sim)
    if (ffila < ifila) return 1;
    // Ler o elemento do inicio da fila
    valor = fila[ifila];
    // Atualizar o inicio da fila
    ifila = ifila + 1;
    // Retornar sucesso
    return 0;
}


