#include <iostream>
using namespace std;

#define MAX 10
int enfileirar(int fila[], int &ffila, int valor);
int desenfileirar(int fila[], int &ifila, int ffila, int &valor);
int menu(void);
void opcao1(int fila[], int &fim);
void opcao2(int fila[], int &ini, int fim);

int main(void) {

    // Declarando uma fila
    int fila[MAX];
    int ifila = 0;
    int ffila = -1;
    int op;

    do {
        op = menu();
        if (op == 1) opcao1(fila, ffila);
        if (op == 2) opcao2(fila, ifila, ffila);
        } while (op != 3);
}

void opcao2(int fila[], int &ini, int fim) {
    int v;
    while( desenfileirar(fila, ini, fim, v) == 0) {
        if (v%5 == 0) cout << v << endl;
    }
}

void opcao1(int fila[], int &fim) {
    int v;
    cout << "Digite um inteiro positivo: ";
    cin >> v;
    enfileirar(fila, fim, v);
}

int menu(void) {
    int op;
    cout << "1. Enfileira" << endl;
    cout << "2. Desenfileira" << endl;
    cout << "3. Termina" << endl;
    cout << "Opcao: ";
    cin >> op;
    return op;
}

// Retorna 0 em caso de sucesso e 1 em caso de fila cheia
int enfileirar(int fila[], int &ffila, int valor) {
    // Verificar se a fila est cheia
    if (ffila >= MAX-1) return 1;
    // Se no estiver
    // Incrementar a posio final
    ffila = ffila + 1;
    // Guardar o valor na posio final
    fila[ffila] = valor;
    // Indica sucesso
    return 0;
}

int desenfileirar(int fila[], int &ifila, int ffila, int &valor) {
    // Verificar se a fila t vazia (e retornar erro se sim)
    if (ffila < ifila) return 1;
    // Ler o elemento do inicio da fila
    valor = fila[ifila];
    // Atualizar o inicio da fila
    ifila = ifila + 1;
    // Retornar sucesso
    return 0;
}


